#  Copyright (c) 2000 Anthony C. D'Agostino
#  http://ourworld.compuserve.com/homepages/scorpius
#  scorpius@compuserve.com
#  October 5, 2000
#  Displacement Mapping Suite (Version 1.0)

import Blender
import math
from Blender import NMesh, Object
from math import *

object = Object.GetSelected()
meshname=object[0].data.name
mesh = NMesh.GetRaw(meshname)

for vertex in mesh.verts:
    theta  = vertex.co[0] * pi     # range was [-1, 1] now [-pi, pi]
    radius = vertex.co[2] + 1

    x = radius*cos(theta)
    y = radius*sin(theta)
    z = vertex.co[1]

    vertex.co[0] = x
    vertex.co[1] = y
    vertex.co[2] = z

NMesh.PutRaw(mesh, meshname)
Blender.Redraw()

