#  Copyright (c) 2000 Anthony C. D'Agostino
#  http://ourworld.compuserve.com/homepages/scorpius
#  scorpius@compuserve.com
#  October 5, 2000
#  Displacement Mapping Suite (Version 1.0)

import Blender
import math
from Blender import NMesh, Object
from math import *

object = Object.GetSelected()
meshname=object[0].data.name
mesh = NMesh.GetRaw(meshname)

for vertex in mesh.verts:
    theta  = vertex.co[0] * pi     # range was [-1, 1] now [-pi, pi]
    phi    = vertex.co[1] * pi
    major_radius = 1.0
    minor_radius = vertex.co[2] + 0.2

    x = (major_radius + minor_radius*cos(phi)) * cos(theta)
    y = (major_radius + minor_radius*cos(phi)) * sin(theta)
    z = minor_radius*sin(phi)

    vertex.co[0] = x
    vertex.co[1] = y
    vertex.co[2] = z

NMesh.PutRaw(mesh, meshname)
Blender.Redraw()

